export declare const Traits: {
    node: {
        id: import("./types_typed").Type<import("./types_typed").Optional<string>, string | null>;
        classes: import("./types_typed").Type<import("./types_typed").Optional<string | string[]>, string[]>;
    };
    entity: {
        active: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    object: {
        visible: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    latch: {
        data: import("./types_typed").Type<unknown, unknown>;
        deep: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean | null>;
    };
    unit: {
        scale: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        fov: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        focus: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    span: {
        range: import("./types_typed").Type<(number | number[] | import("three").Vector2) | null, import("three").Vector2 | null>;
    };
    view: {
        range: import("./types_typed").Type<(number | number[] | import("three").Vector2)[], import("three").Vector2[]>;
    };
    view3: {
        position: import("./types_typed").Type<number | number[] | import("three").Vector3, import("three").Vector3>;
        quaternion: import("./types_typed").Type<(number | number[] | import("three").Vector4) | import("three").Quaternion, import("three").Quaternion>;
        rotation: import("./types_typed").Type<number | number[] | import("three").Vector3, import("three").Vector3>;
        scale: import("./types_typed").Type<number | number[] | import("three").Vector3, import("three").Vector3>;
        eulerOrder: import("./types_typed").Type<import("./types_typed").Optional<string | import("./types_typed").Axes[]>, number[]>;
    };
    view4: {
        position: import("./types_typed").Type<number | number[] | import("three").Vector4, import("three").Vector4>;
        scale: import("./types_typed").Type<number | number[] | import("three").Vector4, import("three").Vector4>;
    };
    layer: {
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        fit: any;
    };
    vertex: {
        pass: any;
    };
    fragment: {
        pass: any;
        gamma: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    transform3: {
        position: import("./types_typed").Type<number | number[] | import("three").Vector3, import("three").Vector3>;
        quaternion: import("./types_typed").Type<(number | number[] | import("three").Vector4) | import("three").Quaternion, import("three").Quaternion>;
        rotation: import("./types_typed").Type<number | number[] | import("three").Vector3, import("three").Vector3>;
        eulerOrder: import("./types_typed").Type<import("./types_typed").Optional<string | import("./types_typed").Axes[]>, number[]>;
        scale: import("./types_typed").Type<number | number[] | import("three").Vector3, import("three").Vector3>;
        matrix: import("./types_typed").Type<number[] | import("three").Matrix4, import("three").Matrix4>;
    };
    transform4: {
        position: import("./types_typed").Type<number | number[] | import("three").Vector4, import("three").Vector4>;
        scale: import("./types_typed").Type<number | number[] | import("three").Vector4, import("three").Vector4>;
        matrix: import("./types_typed").Type<number[] | import("three").Matrix4, import("three").Matrix4>;
    };
    camera: {
        proxy: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        position: import("./types_typed").Type<(number | number[] | import("three").Vector3) | null, import("three").Vector3 | null>;
        quaternion: import("./types_typed").Type<(number | number[] | import("three").Vector4) | import("three").Quaternion | null, import("three").Quaternion | null>;
        rotation: import("./types_typed").Type<(number | number[] | import("three").Vector3) | null, import("three").Vector3 | null>;
        lookAt: import("./types_typed").Type<(number | number[] | import("three").Vector3) | null, import("three").Vector3 | null>;
        up: import("./types_typed").Type<(number | number[] | import("three").Vector3) | null, import("three").Vector3 | null>;
        eulerOrder: import("./types_typed").Type<import("./types_typed").Optional<string | import("./types_typed").Axes[]>, number[]>;
        fov: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
    };
    polar: {
        bend: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        helix: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    spherical: {
        bend: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    stereographic: {
        bend: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    interval: {
        axis: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Axes>, number>;
    };
    area: {
        axes: import("./types_typed").Type<import("./types_typed").Optional<string | import("./types_typed").Axes[]>, number[]>;
    };
    volume: {
        axes: import("./types_typed").Type<import("./types_typed").Optional<string | import("./types_typed").Axes[]>, number[]>;
    };
    origin: {
        origin: import("./types_typed").Type<number | number[] | import("three").Vector4, import("three").Vector4>;
    };
    scale: {
        divide: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        unit: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        base: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        mode: any;
        start: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        end: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        zero: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        factor: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        nice: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    grid: {
        lineX: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        lineY: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        crossed: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        closedX: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        closedY: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    axis: {
        detail: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        crossed: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    data: {
        data: import("./types_typed").Type<unknown, unknown>;
        expr: import("./types_typed").Type<unknown, unknown>;
        bind: import("./types_typed").Type<unknown, unknown>;
        live: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    buffer: {
        channels: import("./types_typed").Type<import("./types_typed").Optional<1 | 4 | 2 | 3>, 1 | 4 | 2 | 3>;
        items: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        fps: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        hurry: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        limit: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        realtime: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        observe: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        aligned: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    sampler: {
        centered: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        padding: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    array: {
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        bufferWidth: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        history: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    matrix: {
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        height: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        history: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        bufferWidth: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        bufferHeight: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    voxel: {
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        height: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        bufferWidth: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        bufferHeight: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        bufferDepth: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    resolve: {
        expr: import("./types_typed").Type<unknown, unknown>;
        items: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    style: {
        opacity: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        color: import("./types_typed").Type<string | number | number[] | import("three").Color, import("three").Color>;
        blending: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").BlendingModes>, import("./types_typed").BlendingModes>;
        zWrite: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        zTest: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        zIndex: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        zBias: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        zOrder: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
    };
    geometry: {
        points: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>;
        colors: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | null>;
    };
    point: {
        size: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        sizes: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | null>;
        shape: any;
        optical: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        fill: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    line: {
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        join: any;
        stroke: any;
        proximity: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        closed: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    mesh: {
        fill: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        shaded: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        normals: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | null>;
        map: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | null>;
        lineBias: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    strip: {
        line: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    face: {
        line: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    arrow: {
        size: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        start: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        end: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    ticks: {
        normal: import("./types_typed").Type<number | number[] | import("three").Vector3, import("three").Vector3>;
        size: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        epsilon: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    attach: {
        offset: import("./types_typed").Type<number | number[] | import("three").Vector2, import("three").Vector2>;
        snap: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    format: {
        digits: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        data: import("./types_typed").Type<unknown, unknown>;
        expr: import("./types_typed").Type<unknown, unknown>;
        live: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    font: {
        font: any;
        style: import("./types_typed").Type<import("./types_typed").Optional<string>, string>;
        variant: import("./types_typed").Type<import("./types_typed").Optional<string>, string>;
        weight: import("./types_typed").Type<import("./types_typed").Optional<string>, string>;
        detail: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        sdf: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    label: {
        text: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>;
        size: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        outline: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        expand: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        background: import("./types_typed").Type<string | number | number[] | import("three").Color, import("three").Color>;
    };
    overlay: {
        opacity: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        zIndex: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    dom: {
        points: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>;
        html: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>;
        size: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        outline: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        zoom: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        color: import("./types_typed").Type<(string | number | number[] | import("three").Color) | null, import("three").Color | null>;
        attributes: import("./types_typed").Type<unknown, unknown>;
        pointerEvents: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    texture: {
        minFilter: any;
        magFilter: any;
        type: any;
    };
    shader: {
        sources: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | null>;
        indices: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        channels: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        language: import("./types_typed").Type<import("./types_typed").Optional<string>, string>;
        code: import("./types_typed").Type<import("./types_typed").Optional<string>, string>;
        uniforms: import("./types_typed").Type<unknown, unknown>;
    };
    include: {
        shader: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>;
    };
    operator: {
        source: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>;
    };
    spread: {
        unit: any;
        items: import("./types_typed").Type<(number | number[] | import("three").Vector4) | null, import("three").Vector4 | null>;
        width: import("./types_typed").Type<(number | number[] | import("three").Vector4) | null, import("three").Vector4 | null>;
        height: import("./types_typed").Type<(number | number[] | import("three").Vector4) | null, import("three").Vector4 | null>;
        depth: import("./types_typed").Type<(number | number[] | import("three").Vector4) | null, import("three").Vector4 | null>;
        alignItems: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Alignments>, import("./types_typed").Alignments>;
        alignWidth: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Alignments>, import("./types_typed").Alignments>;
        alignHeight: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Alignments>, import("./types_typed").Alignments>;
        alignDepth: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Alignments>, import("./types_typed").Alignments>;
    };
    grow: {
        scale: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        items: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Alignments>, import("./types_typed").Alignments | null>;
        width: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Alignments>, import("./types_typed").Alignments | null>;
        height: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Alignments>, import("./types_typed").Alignments | null>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Alignments>, import("./types_typed").Alignments | null>;
    };
    split: {
        order: import("./types_typed").Type<import("./types_typed").Optional<string | import("./types_typed").Axes[]>, number[]>;
        axis: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Axes>, number | null>;
        length: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        overlap: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    join: {
        order: import("./types_typed").Type<import("./types_typed").Optional<string | import("./types_typed").Axes[]>, number[]>;
        axis: import("./types_typed").Type<import("./types_typed").Optional<import("./types_typed").Axes>, number | null>;
        overlap: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    swizzle: {
        order: import("./types_typed").Type<import("./types_typed").Optional<string | import("./types_typed").Axes[]>, number[]>;
    };
    transpose: {
        order: import("./types_typed").Type<import("./types_typed").Optional<string | import("./types_typed").Axes[]>, number[]>;
    };
    repeat: {
        items: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        height: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    slice: {
        items: import("./types_typed").Type<(number | number[] | import("three").Vector2) | null, import("three").Vector2 | null>;
        width: import("./types_typed").Type<(number | number[] | import("three").Vector2) | null, import("three").Vector2 | null>;
        height: import("./types_typed").Type<(number | number[] | import("three").Vector2) | null, import("three").Vector2 | null>;
        depth: import("./types_typed").Type<(number | number[] | import("three").Vector2) | null, import("three").Vector2 | null>;
    };
    reverse: {
        items: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        width: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        height: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    lerp: {
        size: any;
        items: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        height: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
    };
    subdivide: {
        items: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        height: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        bevel: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        lerp: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    resample: {
        indices: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        channels: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        sample: any;
        size: any;
        items: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        height: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
    };
    readback: {
        type: any;
        expr: import("./types_typed").Type<unknown, unknown>;
        data: any;
        channels: import("./types_typed").Type<import("./types_typed").Optional<1 | 4 | 2 | 3>, 1 | 4 | 2 | 3>;
        items: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        height: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        depth: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
    };
    root: {
        speed: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        camera: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>;
    };
    inherit: {
        source: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>;
        traits: import("./types_typed").Type<import("./types_typed").Optional<string>[], string[]>;
    };
    rtt: {
        size: any;
        width: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        height: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        history: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    compose: {
        alpha: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    present: {
        index: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        directed: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        length: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    slide: {
        order: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        steps: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        early: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        late: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        from: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        to: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
    };
    transition: {
        stagger: import("./types_typed").Type<number | number[] | import("three").Vector4, import("three").Vector4>;
        enter: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        exit: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        delay: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        delayEnter: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        delayExit: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        duration: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        durationEnter: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        durationExit: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
    };
    move: {
        from: import("./types_typed").Type<number | number[] | import("three").Vector4, import("three").Vector4>;
        to: import("./types_typed").Type<number | number[] | import("three").Vector4, import("three").Vector4>;
    };
    seek: {
        seek: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
    };
    track: {
        target: import("./types_typed").Type<import("./types_typed").Optional<string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>, string | import("../..").MathboxNode<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step"> | import("../..").MathboxSelection<"axis" | "face" | "grid" | "line" | "point" | "strip" | "surface" | "ticks" | "vector" | "view" | "cartesian" | "cartesian4" | "polar" | "spherical" | "stereographic" | "stereographic4" | "transform" | "transform4" | "vertex" | "fragment" | "layer" | "mask" | "array" | "interval" | "matrix" | "area" | "voxel" | "volume" | "scale" | "latch" | "html" | "dom" | "text" | "format" | "label" | "retext" | "clamp" | "grow" | "join" | "lerp" | "memo" | "readback" | "resample" | "repeat" | "reverse" | "swizzle" | "spread" | "split" | "slice" | "subdivide" | "transpose" | "group" | "inherit" | "root" | "unit" | "shader" | "camera" | "rtt" | "compose" | "clock" | "now" | "move" | "play" | "present" | "reveal" | "slide" | "step">>;
        script: any;
        ease: any;
    };
    trigger: {
        trigger: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
    step: {
        playback: any;
        stops: import("./types_typed").Type<import("./types_typed").Optional<number>[] | null, number[] | null>;
        delay: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        duration: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        pace: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        speed: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        rewind: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        skip: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        realtime: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    play: {
        delay: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        pace: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        speed: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        from: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        to: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        realtime: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
        loop: import("./types_typed").Type<import("./types_typed").Optional<boolean>, boolean>;
    };
    now: {
        now: import("./types_typed").Type<unknown, unknown>;
        seek: import("./types_typed").Type<import("./types_typed").Optional<number>, number | null>;
        pace: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
        speed: import("./types_typed").Type<import("./types_typed").Optional<number>, number>;
    };
};
