declare var _default: "uniform vec4 mapSize;\nuniform vec4 geometryResolution;\nuniform vec4 geometryClip;\nattribute vec4 position4;\n\n// External\nvec3 getPosition(vec4 xyzw, float canonical);\nvec3 getNormal(vec4 xyzw);\n\nvarying vec3 vNormal;\nvarying vec3 vLight;\nvarying vec3 vPosition;\n\nvec3 getSurfacePositionNormal() {\n\n  vec4 p = min(geometryClip, position4);\n#ifdef SURFACE_CLOSED_X\n  if (p.x == geometryClip.x) p.x = 0.0;\n#endif\n#ifdef SURFACE_CLOSED_Y\n  if (p.y == geometryClip.y) p.y = 0.0;\n#endif\n\n  vec3 center = getPosition(p, 1.0);\n  vNormal     = normalMatrix * normalize(getNormal(p));\n  vLight      = normalize((viewMatrix * vec4(1.0, 2.0, 2.0, 0.0)).xyz); // hardcoded directional light\n  vPosition   = -center;\n\n#ifdef POSITION_UV\n#ifdef POSITION_UV_INT\n  vUV = -.5 + (position4.xy * geometryResolution.xy) * mapSize.xy;\n#else\n  vUV = position4.xy * geometryResolution.xy;\n#endif\n#endif\n\n  return center;\n}\n";
export default _default;
